  /****************************************************************************
  * Title                 :   BIG 7 SEG R click
  * Filename              :   7_Seg.c
  * Author                :   SP
  * Origin Date           :   21/11/2016
  * Notes                 :   None
  *****************************************************************************/
  /**
  * @note Test configuration:
  * MCU:             P18F87K22
  * Dev.Board:       EasyPIC PRO v7
  * Oscillator:      16 MHz external
  * Ext. Modules:    BIG 7-SEG R Click
  * SW:              PIC v6.6.3
  *
  *
  /******************************************************************************
  * Includes
  *******************************************************************************/
   #include "7_Seg.h"
  /******************************************************************************
  * Preprocessor Constants
  *******************************************************************************/

  /******************************************************************************
  * Configuration Constants
  *******************************************************************************/

  /******************************************************************************
  * Macros
  *******************************************************************************/

  /******************************************************************************
  * Typedefs
  *******************************************************************************/

  /* Module Variable Definitions
  *******************************************************************************/
  extern sfr sbit HC595_RES;
  extern sfr sbit HC595_LAT;
  /******************************************************************************

  /******************************************************************************
  * Function Prototypes
  *******************************************************************************/

  // Routines
  void HC595_reset()
  {
   HC595_RES = 0;
   Delay_ms(5);
   HC595_RES = 1;
  }

  void HC595_load()
  {
   HC595_LAT = 0;
   Delay_ms(5);
   HC595_LAT = 1;
  }

  char dig_array[MAX_CHARACTERS] =
  {
    0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F,    // digital numbers [0 - 9]
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                      // unsupported characters
    0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71, 0x6F, 0x76, 0x30, 0x1E,    // alphabet letters [A - J]
    0x76, 0x38, 0x15, 0x54, 0x3F, 0x73, 0x67, 0x50, 0x6D, 0x78,    // alphabet letters [K - T]
    0x3E, 0x1C, 0x2A, 0x76, 0x6E, 0x5B,                            // alphabet letters [U - Z]
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                            // unsupported characters
    0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71, 0x6F, 0x76, 0x30, 0x1E,    // alphabet letters [a - j]
    0x76, 0x38, 0x15, 0x54, 0x3F, 0x73, 0x67, 0x50, 0x6D, 0x78,    // alphabet letters [k - t]
    0x3E, 0x1C, 0x2A, 0x76, 0x6E, 0x5B                             // alphabet letters [u - z]
  };

  int8_t seg_7_display(char c)
  {
    uint8_t index;
    uint8_t ret_value;
    char seg;

    if (c < MIN_ASCII_DEC || c > MAX_ASCII_DEC) 
       return -1;

    index = c - ASCII_OFFSET;
    seg = dig_array[index];

    if (seg == 0) 
       return -1;

    else seg7_send_byte(seg);

    return 0;
  }

  void seg7_send_byte (uint8_t sendbyte)
  {       
     SPI_Write(sendbyte);
     HC595_load();
  }