                                                                     /****************************************************************************
* Title                 :   BIG 7 SEG R click
* Filename              :   7_Seg.h
* Author                :   SP
* Origin Date           :   21/11/2016
* Notes                 :   None
*****************************************************************************/
/**************************CHANGE LIST **************************************
*
*    Date    Software Version    Initials     Description
*  21/11/16    1.0.0               SP   1.0.0 - Initial testing and verification 
*
*****************************************************************************/
/**
* @note Test configuration:
* MCU:             P18F87K22
* Dev.Board:       EasyPIC PRO v7
* Oscillator:      16 MHz external
* Ext. Modules:    BIG 7-SEG R Click
* SW:              PIC v6.3.0
*
*/
#ifndef _7_SEG_H
#define _7_SEG_H
/******************************************************************************
* Includes
*******************************************************************************/
#include "stdint.h"
/******************************************************************************
* Preprocessor Constants
*******************************************************************************/
#define MAX_CHARACTERS 75
#define ASCII_OFFSET 48
#define MIN_ASCII_DEC 48
#define MAX_ASCII_DEC 122
/******************************************************************************
* Configuration Constants
*******************************************************************************/

/******************************************************************************
* Macros
*******************************************************************************/

/******************************************************************************
* Typedefs
*******************************************************************************/

/******************************************************************************
* Variables
*******************************************************************************/

/******************************************************************************
* Function Prototypes
*******************************************************************************/

// Routines
void HC595_reset( void );
void HC595_load( void );

// Displaying digital number or letter provided by input character;  -1 - error, 0 - success
int8_t seg_7_display( char c );

// Sending byte using SPI protocol
void seg7_send_byte ( uint8_t byte );

#endif // _7_SEG_H